// GVBAEXT.cpp : DLL ̏[`łB
//

#include "stdafx.h"

// adscmd()̃eXg͓
void gvbaExtCmd()
{
	// shortintlong̃TCY𒲂ׂ
	// 32rbg GVBAEXT sizeof short=2 int=4 long=4 rlname=4
	// 64rbg  GVBAEXT sizeof short=2 int=4 long=4 rlname=8
	resbuf* rbp;
	ads_printf(_T("sizeof short=%d int=%d long=%d rlname=%d\n"), sizeof(short), sizeof(int), sizeof(long), sizeof(rbp->resval.rlname[0]));
	// ~ ads_cmd() ō}
	ads_point pt;
	pt[0] = 100.0;
	pt[1] = 100.0;
	pt[2] = 0.0;
	rbp = ads_buildlist(
		RTSTR, _T("CIRCLE"),
		RT3DPOINT, pt,
		RTREAL, 25.0,
		RTNONE );
	int rc = ads_cmd( rbp );
	ads_printf(_T("GVBAEXT %d\n"),rc);
	ads_relrb( rbp );
}

// NXg̗vfԂ
int length( resbuf* rbp )
{
	int i = 0;
	for( resbuf* p = rbp ; p ; p = p->rbnext )
	{
		++i;
	}
	return i;
}

// Z[tz񂩂烊NXg
resbuf* buildlist( VARIANT iType, VARIANT iData )
{
	resbuf* rbp = 0;
	resbuf* p = 0;
	// iType  16rbg̔z
	// iData  oAg̔zł邱
	if( iType.vt == ( VT_ARRAY | VT_I2 ) &&
		iData.vt == ( VT_ARRAY | VT_VARIANT ))
	{
		// Z[tz̏Ɖ擾
		LONG lb = 0;
		SafeArrayGetLBound( iType.parray, 1, &lb);
		LONG ub = 0;
		SafeArrayGetUBound( iType.parray, 1, &ub);
		// Z[tz̓e擾ăNXg쐬
		for(LONG i = lb ; i <= ub ; i++ )
		{
			// iType  iData ̗vf擾
			short code;
			VARIANT data;
			LONG ii;
			double xyz;
#ifdef _M_X64
			LONGLONG nm;
#else
			LONG nm;
#endif
			SafeArrayGetElement( iType.parray, &i, (void**)&code );
			SafeArrayGetElement( iData.parray, &i, (void**)&data );
			//  rbp Ƀobt@p
			// Qڈȍ~ p->rbnext Ƀobt@p
			if( !rbp )
			{
				rbp = p = ads_newrb(code);
			}
			else
			{
				p->rbnext = ads_newrb(code);
				p = p->rbnext;
			}
			// iTypecodeāAdata擾
			switch( code )
			{
			case RTREAL:
			case RTANG:
			case RTORINT:
				p->resval.rreal = data.dblVal;
				break;
			case RTSHORT:
				if( data.vt == VT_I2 )
					p->resval.rint = data.iVal;
				if( data.vt == VT_I4 )
					p->resval.rint = (short)data.lVal;
				break;
			case RTLONG:
				if( data.vt == VT_I2 )
					p->resval.rlong = data.iVal;
				if( data.vt == VT_I4 )
					p->resval.rlong = data.lVal;
				break;
			case RTSTR:
				// ̈mۂĂRs[
				acutNewString( p->resval.rstring, SysStringLen(data.bstrVal));
				_tcscpy( p->resval.rstring, (LPCTSTR)data.bstrVal);
				break;
			case RTPOINT:
				ii = 0;
				SafeArrayGetElement( data.parray, &ii, &xyz );
				p->resval.rpoint[0] = xyz;
				ii = 1;
				SafeArrayGetElement( data.parray, &ii, &xyz );
				p->resval.rpoint[1] = xyz;
				p->resval.rpoint[2] = 0.0;
				break;
			case RT3DPOINT:
				ii = 0;
				SafeArrayGetElement( data.parray, &ii, &xyz );
				p->resval.rpoint[0] = xyz;
				ii = 1;
				SafeArrayGetElement( data.parray, &ii, &xyz );
				p->resval.rpoint[1] = xyz;
				ii = 2;
				SafeArrayGetElement( data.parray, &ii, &xyz );
				p->resval.rpoint[2] = xyz;
				break;
			case RTENAME:
			case RTPICKS:
				// 32rbgA[LeN`łnm32rbgɂȂ
				// 64rbgA[LeN`łnm64rbgɂȂ
				ii = 0;
				SafeArrayGetElement( data.parray, &ii, &nm );
				p->resval.rlname[0] = nm;
				ii = 1;
				SafeArrayGetElement( data.parray, &ii, &nm );
				p->resval.rlname[1] = nm;
				break;
			// ̑̌^ RTT,RTNIL,RTNONEɂresval͂Ȃ
			}
		}
	}
	return rbp;
}

// NXgZ[tz
void buildArray( resbuf* ret,  VARIANT* oType, VARIANT* oData )
{
	// oAg^ϐ
	VariantInit( oType );
	VariantInit( oData );
	// NXg̗vf擾
	int len = length(ret);
	if( len == 0 )
	{
		oType->vt = VT_EMPTY;
		oData->vt = VT_EMPTY;
		return;
	}
	// Z[tzmۂoAg^ϐɐݒ
	oType->vt = ( VT_ARRAY | VT_I2 );
	oData->vt = ( VT_ARRAY | VT_VARIANT );
	SAFEARRAYBOUND sab = {len,0};
    oType->parray = SafeArrayCreate( VT_I2, 1, &sab );
    oData->parray = SafeArrayCreate( VT_VARIANT, 1, &sab );
	// vfu߂̃oAg^ϐ
	VARIANT data;
	VARIANT data2;
	VariantInit(&data);
	VariantInit(&data2);
	// Z[tz̓Y
	LONG i = 0;
	LONG ii = 0;
	// NXg
	for( resbuf* p = ret; p ; p = p->rbnext, ++i )
	{
		// oTypẽZ[tzɃf[^^ݒ
		SafeArrayPutElement( oType->parray, &i, (void*)&(p->restype));
		// f[^^ɂoDatãZ[tzɒlݒ
		switch( p->restype )
		{
		case RTREAL:
		case RTANG:
		case RTORINT:
			data.vt = VT_R8;
			data.dblVal = p->resval.rreal;
			SafeArrayPutElement( oData->parray, &i, (void*)&data );
			break;
		case RTSHORT:
			data.vt = VT_I2;
			data.iVal = p->resval.rint;
			SafeArrayPutElement( oData->parray, &i, (void*)&data );
			break;
		case RTLONG:
			data.vt = VT_I4;
			data.lVal = p->resval.rlong;
			SafeArrayPutElement( oData->parray, &i, (void*)&data );
			break;
		case RTSTR:
			// Ch񂩂BSTR^쐬
			data.vt = VT_BSTR;
			data.bstrVal = SysAllocString( p->resval.rstring );
			SafeArrayPutElement( oData->parray, &i, (void*)&data );
			break;
		case RTPOINT:
			p->resval.rpoint[2] = 0.0;
		case RT3DPOINT:
			data.vt = ( VT_ARRAY | VT_R8 );
			sab.cElements = 3;
			sab.lLbound = 0;
			data.parray = SafeArrayCreate( VT_R8, 1, &sab );
			data2.vt = VT_R8;
			ii = 0;
			data2.dblVal = p->resval.rpoint[0];
			SafeArrayPutElement( data.parray, &ii, (void*)&data2 );
			ii = 1;
			data2.dblVal = p->resval.rpoint[1];
			SafeArrayPutElement( data.parray, &ii, (void*)&data2 );
			ii = 2;
			data2.dblVal = p->resval.rpoint[2];
			SafeArrayPutElement( data.parray, &ii, (void*)&data2 );
			SafeArrayPutElement( oData->parray, &i, (void*)&data );
			break;
		case RTENAME:
		case RTPICKS:
			sab.cElements = 2;
			sab.lLbound = 0;
#ifdef _M_X64
			data.vt = ( VT_ARRAY | VT_I8 );
			data.parray = SafeArrayCreate( VT_I8, 1, &sab );
			data2.vt = VT_I8;
			ii = 0;
			data2.llVal = p->resval.rlname[0];
			SafeArrayPutElement( data.parray, &ii, (void*)&data2 );
			ii = 1;
			data2.llVal = p->resval.rlname[1];
			SafeArrayPutElement( data.parray, &ii, (void*)&data2 );
#else
			data.vt = ( VT_ARRAY | VT_I4 );
			data.parray = SafeArrayCreate( VT_I4, 1, &sab );
			data2.vt = VT_I4;
			ii = 0;
			data2.lVal = p->resval.rlname[0];
			SafeArrayPutElement( data.parray, &ii, (void*)&data2 );
			ii = 1;
			data2.lVal = p->resval.rlname[1];
			SafeArrayPutElement( data.parray, &ii, (void*)&data2 );
#endif
			SafeArrayPutElement( oData->parray, &i, (void*)&data );
			break;
		default:
			data.vt = VT_EMPTY;
			SafeArrayPutElement( oData->parray, &i, (void*)&data );
			break;
		}
	}
}

//  ads_cmd()̓G[ɂȂ
STDAPI gvbaRun( VARIANT iType, VARIANT iData )
{
	//resbuf* rbp = buildlist( iType, iData );
	//if( rbp )
	//{
	//	int rc = ads_cmd( rbp );
	//	//ads_printf(_T("gvbaRun() %d\n"),rc);
	//	ads_relrb( rbp );
	//}
	ads_alert(_T("G[̂ߖł"));
	return S_OK;
}

// ads_invoke()͓Acommand֐͌ĂׂȂ
STDAPI gvbaInvoke( VARIANT iType, VARIANT iData,  VARIANT* oType, VARIANT* oData )
{
	resbuf* rbp = buildlist( iType, iData );
	resbuf* ret = 0;
	if( rbp )
	{
		int rc = ads_invoke( rbp, &ret );
		//ads_printf(_T("gvbaInvoke() %d\n"),rc);
		ads_relrb( rbp );
		if( ret )
		{
			buildArray( ret, oType, oData );
			ads_relrb( ret );
		}
	}
	return S_OK;
}

// ads_getsym()͓
STDAPI gvbaGetSym( LPCTSTR name, VARIANT* oType, VARIANT* oData )
{
	resbuf* ret = 0;
	int rc = ads_getsym( name, &ret );
	if( ret )
	{
		buildArray( ret, oType, oData );
		ads_relrb( ret );
	}
	return S_OK;
}

// ads_putsym()͓
STDAPI gvbaPutSym( LPCTSTR name, VARIANT iType, VARIANT iData )
{
	resbuf* rbp = buildlist( iType, iData );
	if( rbp )
	{
		int rc = ads_putsym( name, rbp );
		ads_relrb( rbp );
	}
	return S_OK;
}